
-- we are using our own rosterlib for now because missing online/offline information in the event

function TuiRaidTracker:ChangeOnlinestatus(unitname,online)
    self:Debug("changeonlinestatus",unitname,online)
    if online and self.cr.online[unitname] ~= 1 then
        self:Debug("+++",unitname,"joined",self:get_player(unitname))
        self.cr.online[unitname] = 1
        table.insert(self.cr.joins, { time(), self:get_player(unitname) })
        self:UpdateDisplay()    
    elseif not online and self.cr.online[unitname] ~= 0 then 
        self:Debug("+++",unitname,"left",self:get_player(unitname))
        self.cr.online[unitname] = 0;
        table.insert(self.cr.leaves, { time(), self:get_player(unitname) })
        self:UpdateDisplay()
    end
end


function TuiRaidTracker:get_player(name) 
    local i = 0
    
    if not TLR.cr then return end
    if TLR.raid[TLR.cr].players[name] then
        return TLR.raid[TLR.cr].players[name]
    else 
        for key,value in pairs(TLR.raid[TLR.cr].players) do 
            if (type(value) == "number") and (value > i) then i = value end
        end
        TLR.raid[TLR.cr].players[name] = i+1
        TLR.raid[TLR.cr].players[i+1] = name
        return TLR.raid[TLR.cr].players[name]
    end
end

function TuiRaidTracker:RosterLib_UnitChanged(unitid, name, class,  subgroup, rank, oldname, oldunitid, oldclass, oldsubgroup, oldrank, online,oldonline)
    if (class ~= "PET") and (oldclass ~= "PET") then
               
        -- self:Debug("---- ",unitname,"name", name,"oldname", oldname,  "online",online,"oldonline",oldonline)
        
        if not oldname and name then 
            self:Debug("Joined",name)
            self:ChangeOnlinestatus(name,true)
        elseif oldname and not name then
            self:Debug("Left",oldname)
            self:ChangeOnlinestatus(oldname,false)
        elseif oldonline and not online then
            self:Debug("Offline",name)
            self:ChangeOnlinestatus(name,false)
        elseif online and not oldonline then
            self:Debug("Online",name)
            self:ChangeOnlinestatus(name,true)
        end

    end
end
